import java.math.BigInteger ;
import java.io.* ;
public class pr93 {
    static final int N = 30 ;
    static BigInteger fact[] = new BigInteger[N] ;
    static BigInteger comb[][] = new BigInteger[N][N] ;
    static BigInteger f[][] = new BigInteger[N][N] ;
    static BigInteger dera[] = new BigInteger[N] ;
    static BigInteger ZERO = new BigInteger("0") ;
    static BigInteger ONE = new BigInteger("1") ;
    static BigInteger nbi(int i) {
        return new BigInteger(""+i) ;
    }
    static {
        fact[0] = ONE ;
        for (int i=1; i<N; i++)
            fact[i] = fact[i-1].multiply(nbi(i)) ;
        for (int i=0; i<N; i++)
            comb[i][0] = comb[i][i] = ONE ;
        for (int i=2; i<N; i++)
            for (int j=1; j+j<=i; j++)
                comb[i][j] = comb[i][i-j] = comb[i][j-1].multiply(nbi(i-j+1)).divide(nbi(j)) ;
        dera[0] = ONE ;
        dera[1] = ZERO ;
        for (int i=2; i<N; i++) {
            dera[i] = fact[i].subtract(nbi(1)) ;
            for (int j=1; j<i; j++)
                dera[i] = dera[i].subtract(comb[i][j].multiply(dera[i-j])) ;
        }
        for (int i=0; i<N; i++)
            f[i][0] = dera[i] ;
        for (int i=0; i<N; i++)
            for (int j=1; j<=i; j++)
                f[i][j] = f[i][j-1].add(f[i-1][j-1]) ;
    }
    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in)) ;
        int n = Integer.parseInt(br.readLine()) ;
        BigInteger ind = new BigInteger(br.readLine()) ;
        boolean used[] = new boolean[N] ;
        int dig[] = new int[N] ;
        ind = ind.subtract(ONE) ;
        for (int i=0; i<n; i++) {
            int a = 0 ;
            for (int j=0; j<i; j++)
                if (dig[j] > i)
                    a++ ;
            for (int p=0; p<n; p++) {
                if (used[p] || p == i)
                    continue ;
                BigInteger tt = null ;
                if (p < i)
                    tt = f[n-i-1][a] ;
                else
                    tt = f[n-i-1][a+1] ;
                //System.out.println("Pos " + i + " test " + p + " gives " + tt) ;
                if (tt.compareTo(ZERO) > 0) {
                    if (tt.compareTo(ind) <= 0) {
                        ind = ind.subtract(tt) ;
                    } else {
                        dig[i] = p ;
                        used[p] = true ;
                        break ;
                    }
                }
            }
        }
        for (int i=0; i<n; i++)
            System.out.print((char)('A'+dig[i])) ;
        System.out.println() ;
    }
}