import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;


public class pr95 {
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		
		int n = in.nextInt();
		ArrayList<Pear> pears = new ArrayList<Pear>();
		for (int i=0; i<n; i++) {
			in.nextLine();
			pears.add(new Pear(in.nextInt(), in.nextInt()));
		}
		
		in.nextLine();
		int m = in.nextInt();
		Chamber[] chambers = new Chamber[m];
		for (int i=0; i<m; i++) {
			in.nextLine();
			chambers[i] = new Chamber(in.nextInt(), in.nextInt());
		}
		
		Collections.sort(pears);
		Arrays.sort(chambers);
		
		int chambersIndex = 0;
		int pearsRipened = 0;
    int con;
		while (chambersIndex < chambers.length && pears.size() > 0) {	
			if (chambers[chambersIndex].capacity > 0) {
			  for (int i=0; i<pears.size(); i++) {
				  if (chambers[chambersIndex].capacity < 1) break;
				
				  con = chambers[chambersIndex].concentration;
				  if (con >= pears.get(i).min && con <= pears.get(i).max) {
					  pears.remove(i);
					  pearsRipened++;
					  chambers[chambersIndex].capacity--;
					  i--;
				  }
			  }
      }
			chambersIndex++;
		}
		
		System.out.println(pearsRipened);
	}
	
	public static class Pear implements Comparable<Pear> {
		public int min, max;
		
		public Pear(int a, int b) {
			this.min = a;
			this.max = b;
		}
		
		public int compareTo(Pear other) {
			if (this.max > other.max) {
				return 1;
			} else if (this.max < other.max) {
				return -1;
			} else {
				return 0;
			}
		}
	}
	
	public static class Chamber implements Comparable<Chamber> {
		public int concentration, capacity;
		public Chamber (int a, int b) {
			this.concentration = a;
			this.capacity = b;
		}
		public int compareTo(Chamber other) {
			if (this.concentration > other.concentration) {
				return 1;
			} else if (this.concentration < other.concentration) {
				return -1;
			} else {
				return 0;
			}
		}
		
	}
}

